//
// Created by nicol on 2018-03-18.
//

#include <stdlib.h>
#include <string.h>
#include "buffer.h"

struct st_buffer {
    size_t   size;
    uint8_t* data;
    uint8_t  own_data;
};

buffer_t buffer_create(size_t size) {
    buffer_t buf = malloc(sizeof(struct st_buffer));
    buf->size = size;
    buf->data = malloc(size);
    buf->own_data = 1;
    return buf;
}

inline void buffer_destroy(buffer_t buffer) {
    if (buffer->own_data) {
        free(buffer->data);
    }
    free(buffer);
}

buffer_t buffer_from(const uint8_t* data, size_t size) {
    buffer_t buf = malloc(sizeof(struct st_buffer));
    buf->size = size;
    buf->data = (uint8_t*)data;
    buf->own_data = 0;
    return buf;
}

buffer_t buffer_copyfrom(const uint8_t* data, size_t size) {
    buffer_t buf = malloc(sizeof(struct st_buffer));
    buf->size = size;
    buf->data = malloc(size);
    memcpy(buf->data, data, size);
    buf->own_data = 1;
    return buf;
}

inline size_t buffer_size(buffer_t buffer) {
    return buffer->size;
}

inline uint8_t* buffer_data(buffer_t buffer) {
    return buffer->data;
}